#RMChart_Include=1
XIncludeFile "RMChart.pbi"

DisableExplicit

;  23/02/2007 - Sample code to read & chart a comma seperated values file which is an 
;  output file from my Rainguage rainfall recording application. 
;  ( Rg is Almost ready For release :-) ) 
;  Regards, Baldrick 

#Title="Rainguage Chartmaker Test" 
#Flags_Main=#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered 
#Width=650 
#Height=600 

Enumeration ; Windows
  #Window_0 
EndEnumeration 

Enumeration 21 ; to allow for up to 20 charts to be in use ( I did initially have a small
  #Btn_1Year_Bar ; problem with clashing constants in this code before I did this. )
  #Btn_1Year_Line
  #Frame_Chart 
  #CsvFile 
EndEnumeration 

Enumeration #WM_USER+1024 ; Chart
  #Chart_1 
EndEnumeration 

Enumeration 1 ; Region
  #Region_1  
EndEnumeration 

Structure rInfo 
  rMnth.s  
  rData.d[32] 
EndStructure 

Global NewList nlDat.rInfo()  
Global Dim arrayDat.d(0) 
Global IsChart_1.l

Procedure Csv_Read(File$) 
  If ReadFile(#CsvFile,File$) 
    Dat$=ReadString(#CsvFile) 
    CommaCount.l=CountString(Dat$,",") 
    If CommaCount=12 ; anything other than 12 comma's = not from my Rainguage app 
      ClearList(nlDat()) 
      For a=1 To 13  
        AddElement(nlDat())  
        DelDat$=StringField(Dat$,a,",") 
        nlDat()\rMnth=DelDat$
      Next
      For b=1 To 31   
        Dat$=ReadString(#CsvFile)  
        FirstElement(nlDat())   
        For index=1 To 13 
          nlDat()\rData[b]=ValF(StringField(Dat$,index,","))  
          NextElement(nlDat()) 
        Next 
      Next 
      Result.l=1 
      Qty.l=ListSize(nlDat()) 
      Dim arrayDat.d(Qty) ;setup array dimension with required useable Qty prior to using 
    Else 
      MessageRequester(#Title,"Incompatible Csv file",#MB_ICONERROR) 
      ClearList(nlDat()) 
    EndIf 
    CloseFile(#CsvFile) 
    ProcedureReturn Result  
  Else 
    MessageRequester(#Title,"Unable to read file",#MB_ICONERROR)
  EndIf 
EndProcedure 

Procedure Process_1YearFile(File$) 
  If Csv_Read(File$)  
    FirstElement(nlDat()) ; this will be initial header data 
    For a=1 To 13 
      NextElement(nlDat())  ; jump the header data & go straight to readings data 
      For b=1 To 31 
        arrayDat(a)+nlDat()\rData[b] 
      Next 
    Next 
    ProcedureReturn 1 
  EndIf 
EndProcedure 

Procedure.s ChooseFile() 
  Title$=#Title+" please select file" 
  DefaultFile$=""
  File$=OpenFileRequester(Title$,DefaultFile$,"Comma seperated values file (.csv)|*.csv",0)  
  ProcedureReturn File$  
EndProcedure 

Procedure Blank_Chart() 
  If IsChart_1 
    IsChart_1=0 
    RMC_DeleteChart(#Chart_1) 
  EndIf 
  Caption$="Baldrick's Rainguage Chartmaker"
  If RMC_CreateChart(WindowID(#Window_0),#Chart_1,20,100,#width-40,#Height-120,9935799,#RMC_CTRLSTYLEIMAGETILED,0,"100_2174.JPG","0")=#RMC_NO_ERROR 
    If RMC_AddRegion(#Chart_1,10,10,-5,-5)=#RMC_NO_ERROR   
      RMC_AddCaption(#Chart_1,#Region_1,Caption$,#White,#Blue,12,1)    
      RMC_Draw(#Chart_1) 
      IsChart_1=1 
      ProcedureReturn 1 
    EndIf 
  EndIf
EndProcedure 

Procedure Make_Chart_1YearLine(Captions$) 
  Qty.l=ListSize(nlDat()) 
  Dim bDat.d(Qty) 
  If IsChart_1 
    IsChart_1=0 
    RMC_DeleteChart(#Chart_1) 
  EndIf 
  FirstElement(nlDat()) ; unwanted info in 1st element for this chart 
  For a=1 To 12 
    NextElement(nlDat()) 
    Label$+Mid(nlDat()\rMnth,1,3) 
    If a<12 
      Label$+"*" 
    EndIf 
    Total.d+arrayDat(a) 
    bDat(a)=Total
  Next 
  If RMC_CreateChart(WindowID(#Window_0),#Chart_1,20,100,#width-40,#Height-120,#White)=#RMC_NO_ERROR 
    If RMC_AddRegion(#Chart_1,10,10,-5,-5)=#RMC_NO_ERROR  
      If RMC_AddCaption(#Chart_1,#Region_1,Captions$,#White,#Black,12,1)=#RMC_NO_ERROR 
        If RMC_AddGrid(#Chart_1,#Region_1,16646122,#True)=#RMC_NO_ERROR  
          If RMC_AddDataAxis(#Chart_1,#Region_1,0,0,1500,11)=#RMC_NO_ERROR  
            If RMC_AddLabelAxis(#Chart_1,#Region_1,Label$,1,12)=#RMC_NO_ERROR  
              If RMC_AddLineSeries(#Chart_1,#Region_1,@arrayDat(1),12, 0,0,#RMC_LINE,#RMC_LINE_FLAT,#RMC_LSTYLE_LINE_AREA,#False,65280,#RMC_SYMBOL_DIAMOND_SMALL,1,#True,#RMC_HATCHBRUSH_OFF)=#RMC_NO_ERROR  
                If RMC_AddLineSeries(#Chart_1,#Region_1,@bDat(1),12, 0,0,#RMC_LINE,#RMC_LINE_FLAT,#RMC_LSTYLE_LINE,#False,16711680,#RMC_SYMBOL_DIAMOND_SMALL,1,#True,#RMC_HATCHBRUSH_OFF)=#RMC_NO_ERROR 
                  If RMC_AddLegend(#Chart_1,#Region_1,"Monthly rainfall mm*Total Rainfall mm",#RMC_LEGEND_TOP,#White,0,#Black)=#RMC_NO_ERROR  
                    RMC_Draw(#Chart_1) 
                    IsChart_1=1 
                    ProcedureReturn 1 
                  EndIf 
                EndIf 
              EndIf  
            EndIf 
          EndIf 
        EndIf 
      EndIf 
    EndIf 
  EndIf 
EndProcedure 

Procedure Make_Chart_1YearBar(Caption$) 
  If IsChart_1 
    IsChart_1=0 
    RMC_DeleteChart(#Chart_1) 
  EndIf  
  FirstElement(nlDat()) ; unwanted info in 1st element for this chart 
  For a=1 To 12 
    NextElement(nlDat()) 
    Label$+Mid(nlDat()\rMnth,1,3) 
    If a<12 
      Label$+"*" 
    EndIf 
    Total.d+arrayDat(a) 
  Next 
  Total$="Year Total "+StrD(Total,2)+"mm" 
  nAverage.d 
  If RMC_CreateChart(WindowID(#Window_0),#Chart_1,20,100,#width-40,#Height-120,#White)=#RMC_NO_ERROR 
    If RMC_AddRegion(#Chart_1,10,10,-5,-5)=#RMC_NO_ERROR  
      If RMC_AddCaption(#Chart_1,#Region_1,Caption$,#White,#Blue,12,1)=#RMC_NO_ERROR  
        If RMC_AddGrid(#Chart_1,#Region_1,16646122,1)=#RMC_NO_ERROR   
          If RMC_AddDataAxis(#Chart_1,#Region_1,0,0,350,15)=#RMC_NO_ERROR 
            If RMC_AddLabelAxis(#Chart_1,#Region_1, Label$,1,0,0,0,0,0,0,0,"")=#RMC_NO_ERROR 
              If RMC_AddBarSeries(#Chart_1,#Region_1,@arrayDat(1),12,#RMC_BARSINGLE,#RMC_COLUMN_3D_GRADIENT,#True,#ColorTransparent,#False,1,#True,1,#RMC_HATCHBRUSH_OFF)=#RMC_NO_ERROR     
                If RMC_CalcAverage(#Chart_1,#Region_1,1,@nAverage,@nL,@nT,@nR,@nB)=#RMC_NO_ERROR 
                  If RMC_CODash(#Chart_1,1,nL,nT,nR,nB,#RMC_LINE_FLAT_DOT,#Blue,0,2)=#RMC_NO_ERROR 
                    If RMC_COText(#Chart_1,2," Year Average " + StrD(nAverage,2)+"mm",nl+40,nT-20,130,20,#RMC_BOX_FLAT_SHADOW,#Blue,#White,96,#RMC_LINE_HORIZONTAL,#White,"8" )=#RMC_NO_ERROR 
                      If RMC_COText(#Chart_1,3,Total$,245,50,120,20,#RMC_BOX_GRADIENTV_SHADOW)=#RMC_NO_ERROR 
                        RMC_Draw(#Chart_1) 
                        IsChart_1=1 
                        ProcedureReturn 1 
                      EndIf 
                    EndIf 
                  EndIf 
                EndIf 
              EndIf 
            EndIf 
          EndIf 
        EndIf 
      EndIf 
    EndIf 
  EndIf  
EndProcedure 

Procedure Open_WindowMain() 
  If OpenWindow(#Window_0,0,0,#Width,#Height,#Title,#Flags_Main) 
    ButtonGadget(#Btn_1Year_Bar,10,10,90,25,"1 year Bar Chart") 
    ButtonGadget(#Btn_1Year_Line,105,10,90,25,"1 year line chart")
    Frame3DGadget(#Frame_Chart,6,85,#Width-10,#Height-95,"",#PB_Frame3D_Double) 
    If Blank_Chart() 
      ProcedureReturn 1 
    EndIf 
  EndIf 
EndProcedure 

If Open_WindowMain()=0  
  End 
EndIf 

Repeat 
  Ev.l=WaitWindowEvent() 
  If Ev=#PB_Event_Gadget 
    Select EventGadget() 
      Case #Btn_1Year_Bar 
        File$=ChooseFile() 
        If File$<>"" 
          Name$=GetFilePart(File$) 
          Period.l=FindString(Name$,".",1) 
          If Period 
            Name$=Left(Name$,Period-1) 
          EndIf
          If Process_1YearFile(File$) 
            If Make_Chart_1YearBar(Name$) 
              Dim arrayDat.d(0) ; just to clear data after use 
              ClearList(nlDat()) 
            EndIf 
          EndIf 
        EndIf 
      Case #Btn_1Year_Line  
        File$=ChooseFile() 
        If File$<>"" 
          Name$=GetFilePart(File$) 
          Period.l=FindString(Name$,".",1) 
          If Period 
            Name$=Left(Name$,Period-1) 
          EndIf
          If Process_1YearFile(File$) 
            If Make_Chart_1YearLine(Name$)  
              Dim arrayDat.d(0) ; just to clear data after use 
              ClearList(nlDat()) 
            EndIf  
          EndIf  
        EndIf    
    EndSelect 
  EndIf 
  If Ev=#PB_Event_CloseWindow 
    Select EventWindow() 
      Case #Window_0 
        Quit.l=1 
    EndSelect 
  EndIf 
Until Quit 
CloseWindow(#Window_0) ; comment this out & program will crash 

; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 5
; Folding = --
; EnableOnError
; Executable = ..\WeatherChart\WeatherChartV2\RainguageChartMakerTest_1.exe